#ifndef QUADRATURETETRAHEDRONDATA_HPP
#define QUADRATURETETRAHEDRONDATA_HPP

#include <format>
#ifdef BUILD_IA
#include "IAInterval.hpp"
#endif

/**
 * For analytical background see:
 * [1] D.A. Dunavant
 *     High Degree Efficient Symmetrical Gaussian Quadrature Rules for the Triangle
 *     International Journal for Numerical Methods in Engineering (1985)
 * [2] F.D. Witherden, P.E. Vincent
 *     On the identification of symmetric quadrature rules for finite element methods
 *
 * The coefficients for non-verified quadrature rules are taken from [2].
 */

template<typename T = double>
struct QtetSymT_data0 {
  T weight;
};

template<typename T = double>
struct QtetSymT_data1 {
  T weight;
  T A;
  T B;
};

template<typename T = double>
struct QtetSymT_data2 {
  T weight;
  T A;
  T B;
};

template<typename T = double>
struct QtetSymT_data3 {
  T weight;
  T A;
  T B;
  T C;
};

template<typename T = double>
struct QtetSymT_data4 {
  T weight;
  T A;
  T B;
  T C;
  T D;
};

template<typename T = double>
struct QtetSymT_data {
  std::vector<QtetSymT_data0<T>> d0;
  std::vector<QtetSymT_data1<T>> d1;
  std::vector<QtetSymT_data2<T>> d2;
  std::vector<QtetSymT_data3<T>> d3;
  std::vector<QtetSymT_data4<T>> d4;

  int Size() { return d0.size() + 4 * d1.size() + 6 * d2.size() + 12 * d3.size() + 24 * d4.size(); }
};

template<typename T = double>
QtetSymT_data<T> GetQtetSymT_data(int exactUpTo);

template<>
QtetSymT_data<double> GetQtetSymT_data<double>(int exactUpTo) {
  switch (exactUpTo) {
  case 0:
  case 1:
    return QtetSymT_data<double>({{0.16666666666666666}}, {}, {}, {}, {});
  case 2:
    return QtetSymT_data<double>({}, {{0.041666666666666664, 0.58541019662497, 0.13819660112501}},
                                 {}, {}, {});
  case 3:
    return QtetSymT_data<double>({{-0.1333333333333333}}, {{0.075, 0.5, 0.16666666666666666}}, {},
                                 {}, {});
  case 4:
    return QtetSymT_data<double>({{-0.013155555555555556}},
                                 {{0.007622222222222222, 0.7857142857142857, 0.07142857142857142}},
                                 {{0.024888888888888887, 0.10059642383320078, 0.3994035761667992}},
                                 {}, {});
  case 5:
    return QtetSymT_data<double>({},
                                 {{0.018781320953002643, 0.06734224221009821, 0.3108859192633006},
                                  {0.012248840519393659, 0.7217942490673264, 0.09273525031089122}},
                                 {{0.007091003462846911, 0.04550370412564965, 0.45449629587435036}},
                                 {}, {});
  case 6:
    return QtetSymT_data<double>({},
                                 {{0.006653791709694583, 0.35619138622254387, 0.21460287125915203},
                                  {0.001679535175886774, 0.877978124396166, 0.04067395853461135},
                                  {0.009226196923942455, 0.0329863295731736, 0.3223378901422755}},
                                 {},
                                 {{0.008035714285714287, 0.2696723314583157, 0.06366100187501753,
                                   0.6030056647916492}},
                                 {});
  case 7:
    return QtetSymT_data<double>({{0.015914214910688475}},
                                 {{0.007054930201661171, 0.05289655066539156, 0.3157011497782028}},
                                 {{0.005316154638809596, 0.05048982259839637, 0.44951017740160365}},
                                 {{0.006201188454722437, 0.04716070036099784, 0.18883383102600104,
                                   0.5751716375870001},
                                  {0.0013517951383172236, 0.14663881381848498, 0.021265472541483248,
                                   0.8108302410985485}},
                                 {});
  case 8:
    return QtetSymT_data<double>({},
                                 {{0.001066191296650387, 0.8809737307888303, 0.039675423070389904},
                                  {0.006698408003494361, 0.05653659790571108, 0.3144878006980963},
                                  {0.004051329250795053, 0.6940399208118901, 0.1019866930627033},
                                  {0.00914314873561624, 0.44738890915242546, 0.1842036969491915}},
                                 {{0.005953268705683197, 0.0634362877545399, 0.4365637122454601}},
                                 {{0.0011971984496420898, 0.236687753825078, 0.021690162067728006,
                                   0.719931922039466},
                                  {0.0027286969908865196, 0.010462648597599378, 0.2044800806367957,
                                   0.5805771901288093}},
                                 {});
  case 9:
    return QtetSymT_data<double>({{0.009149755765608022}},
                                 {{0.0007030428927572789, 0.886434938140015, 0.03785502061999504},
                                  {0.003914020518974665, 0.4913668010496335, 0.1695443996501222},
                                  {0.0007021390916339818, 0.8354757872674994, 0.05484140424416689},
                                  {0.004991187734238021, 0.03310848427236823, 0.3222971719092106}},
                                 {{0.006159069584465227, 0.10961777508972034, 0.39038222491027963}},
                                 {{0.0013622487069517523, 0.0016398199557154935, 0.4591576603859054,
                                   0.08004485927247373},
                                  {0.0016466310935037982, 0.21527026426851525, 0.032966947753572104,
                                   0.7187958402243405},
                                  {0.0036011979031987406, 0.036275799162403644, 0.18174359672117482,
                                   0.6002370073952468}},
                                 {});
  case 10:
    return QtetSymT_data<double>({{0.007623649717471728}},
                                 {{0.0018212126848540283, 0.6572442459097919, 0.11425191803006936},
                                  {9.225389032044115e-05, 0.9680862929638225, 0.010637902345392485},
                                  {0.0042822298565221165, 0.061777874993930615,
                                   0.31274070833535644}},
                                 {{9.231274942880518e-05, 0.01631296303281644,
                                   0.48368703696718357}},
                                 {{0.0017414040048971573, 0.33308633013499633, 0.034306229631804526,
                                   0.5983012106013946},
                                  {0.004189741004418812, 0.28187096726151456, 0.12346418534551117,
                                   0.4712006620474631},
                                  {0.0019643677987493248, 0.014696608428976299, 0.4099196293318112,
                                   0.1654641329074013},
                                  {0.002220037456477751, 0.02289136893700927, 0.17397243903011717,
                                   0.6291637530027564},
                                  {0.001026645962609936, 0.1278262917438523, 0.03002157005631784,
                                   0.812130568143512}},
                                 {});
  case 11:
    return QtetSymT_data<double>({},
                                 {{0.002687831022629367, 0.6261831865216351, 0.1246056044927883},
                                  {0.0002981205696872619, 0.921711077029376, 0.026096307656874648},
                                  {0.0014125489139052057, 0.7841835023260335, 0.07193883255798884},
                                  {0.002063368773241115, 0.021666326373889655, 0.3261112245420368},
                                  {0.0036759778286656933, 0.11782351630425614, 0.2940588278985813},
                                  {0.003826275779440457, 0.42185802685103535, 0.1927139910496549}},
                                 {{0.0002009230450242262, 0.0004712720469277395,
                                   0.49952872795307224},
                                  {0.004132302625274072, 0.1032136020748095, 0.3967863979251905}},
                                 {{0.002006464727467256, 0.28254700436124924, 0.043499899201597414,
                                   0.6304531972355559},
                                  {0.0003156170074970702, 0.14678642789008312, 0.014148392894222993,
                                   0.8249167863214709},
                                  {0.00306458820375969, 0.039967149769866706, 0.21646077368258426,
                                   0.5271113028649648},
                                  {0.0006254154163361041, 0.0007767989493191463,
                                   0.13301884366834713, 0.7331855137139865},
                                  {0.0010554830694899189, 0.0038368679439463593, 0.4405475681061372,
                                   0.11506799584377922}},
                                 {});
  case 12:
    return QtetSymT_data<double>({{0.003900969858113447}},
                                 {{0.000807449910784026, 0.420438366689583, 0.1931872111034723},
                                  {0.0001331088396878883, 0.945648958856903, 0.01811701371436567},
                                  {0.002186453348014594, 0.678977445057218, 0.10700751831426067},
                                  {0.003920304935487943, 0.10191478852087887, 0.29936173715970704},
                                  {0.0003514348041569163, 8.999999999925734e-06,
                                   0.33333033333333334},
                                  {7.9732164939361e-05, 0.5027389297773508, 0.1657536900742164}},
                                 {{0.0003409103903614255, 0.04009986052352576,
                                   0.45990013947647423}},
                                 {{0.0005576272194530285, 0.3611367131488, 0.019518444637611314,
                                   0.5998263975759773},
                                  {0.0019684080374654587, 0.026580905774715224, 0.24970741896308715,
                                   0.4740042562991105},
                                  {0.0004835949838039036, 0.015952969088371183, 0.07674205857869955,
                                   0.8305629137542297},
                                  {0.0015820844091695896, 0.022659220725888336, 0.4301140962791522,
                                   0.11711258671580727},
                                  {0.003490030596809581, 0.2783892049042844, 0.12197854304894212,
                                   0.4776537089978313},
                                  {0.00028572644389568175, 0.15955235893843933,
                                   0.014804823190316825, 0.810837994680927}},
                                 {{0.0012665265902889514, 0.02251830769546779, 0.09851236025042828,
                                   0.22646235632397177, 0.6525069757301322}});
  case 13:
    return QtetSymT_data<double>({{0.0036526332420212144}},
                                 {{0.0013493212333427543, 0.7019398070491519, 0.0993533976502827},
                                  {0.00021719864174546467, 0.9291438021850129,
                                   0.023618732604995685},
                                  {0.0033276844600237036, 0.09732500387282006, 0.30089166537572665},
                                  {0.003542842926679278, 0.4553012715772856, 0.18156624280757147}},
                                 {{0.00012888648456197118, 0.0042816063915288, 0.4957183936084712},
                                  {0.002925818982617384, 0.12290357421888443, 0.3770964257811156}},
                                 {{0.0003563839350027665, 0.003256047953470398, 0.2831821977020273,
                                   0.430379556642475},
                                  {0.00042760028213889773, 0.12032279172480043,
                                   0.022394859045249706, 0.8348874901847002},
                                  {0.0005649232474262137, 0.2792466110144656, 0.02191788402113435,
                                   0.6769176209432657},
                                  {0.001893047217505464, 0.04756854625191953, 0.21481417044274656,
                                   0.5228031128625874},
                                  {0.0018386731369962684, 0.24689045570275148, 0.08000490008644309,
                                   0.5930997441243623},
                                  {0.0007626709563099206, 0.01843785932012887, 0.115794661502719,
                                   0.7499728176744331},
                                  {0.0013789051737014468, 0.029059119231998665, 0.39129315347000476,
                                   0.1883545738279918},
                                  {0.0009777352756532333, 0.022020331694577965, 0.45315745821242837,
                                   0.0716647518805653}},
                                 {{0.0005224308698997493, 0.005618779247001691, 0.11337680937216879,
                                   0.27324999892429636, 0.6077544124565332}});
  case 14:
    return QtetSymT_data<double>({},
                                 {{0.0014973788704248636, 0.6188969623689439, 0.1270343458770187},
                                  {0.0003923581624469805, 0.8885107385971398, 0.03716308713428675},
                                  {0.0012225897780606283, 0.07206514547176801, 0.30931161817607733},
                                  {0.00060104889371439, 0.7666355947813779, 0.07778813507287403},
                                  {3.7994426703648736e-05, 0.9643716500894864,
                                   0.011876116636837864}},
                                 {{0.000708447885384909, 0.023711897155713584, 0.4762881028442864}},
                                 {{0.0008370494569744286, 0.1701227338622343, 0.04551422172971296,
                                   0.7388488226783397},
                                  {0.0011068419993653237, 0.2494768678347754, 0.1945705543105942,
                                   0.36138202354403615},
                                  {0.001081105126086797, 0.02202591861375819, 0.42158193164647034,
                                   0.13481021809330113},
                                  {0.00180820768253443, 0.09100846759454445, 0.3622766180320243,
                                   0.1844382963414069},
                                  {0.0011637092873345476, 0.015400408297877477, 0.26662003783461097,
                                   0.4513595160329006},
                                  {0.001762738663522402, 0.3040525680217463, 0.07870367664603756,
                                   0.5385400786861786},
                                  {0.0002875289791582342, 0.28934148031380513, 0.014626048439494522,
                                   0.6814064228072059},
                                  {0.0017733767321003906, 0.08846911516523143, 0.20755902173331722,
                                   0.4964128413681342},
                                  {5.2712065698718546e-05, 0.10793010186651797,
                                   0.0031767256658013303, 0.8857164468018793},
                                  {0.0011270201562170062, 0.025092174471772033, 0.16634658949265577,
                                   0.6422146465429164}},
                                 {{0.0004889529113768527, 0.007721059899909303, 0.09184894742581438,
                                   0.30344194369885263, 0.5969880489754237},
                                  {0.00015300613200013965, 0.00016446781249784825,
                                   0.06021328978843793, 0.12582571438467238, 0.8137965280143918}});
  case 15:
    return QtetSymT_data<double>({},
                                 {{0.0025194251890684476, 0.15627753786499876, 0.28124082071166706},
                                  {2.8978445074833884e-06, 0.999997, 1e-06},
                                  {0.0006809753367311961, 0.008310478977024416,
                                   0.3305631736743252}},
                                 {{0.0009882517280567792, 0.05655437237844684, 0.44344562762155315},
                                  {0.0023667522066772068, 0.13406515374085695, 0.3659348462591431},
                                  {0.000227639266036769, 0.01239081855247818, 0.4876091814475218}},
                                 {{0.0009964060405867824, 0.06747933763715719, 0.14221122178861695,
                                   0.6480982187856089},
                                  {0.0003556432118837246, 0.3070361787664879, 0.02090030455681823,
                                   0.6511632121198756},
                                  {0.0001429186801813319, 0.002641288166584377, 0.10144207052995867,
                                   0.7944745707734983},
                                  {0.0010923640388573253, 0.28557363039300276, 0.0877556546148307,
                                   0.5389150603773358},
                                  {0.00024206559890479885, 0.11774892947956606,
                                   0.019984365045733636, 0.8422823404289667},
                                  {0.0002462753466868341, 0.06073094678281532, 0.06649943952962487,
                                   0.8062701741579349},
                                  {0.0018025902844338445, 0.06609352390681217, 0.25438425646033347,
                                   0.4251379631725209},
                                  {4.11773963224517e-05, 0.21786973435767654, 0.002345408563036062,
                                   0.7774394485162514},
                                  {0.00039109612903249575, 0.00021759722811187654,
                                   0.21804126228722165, 0.5636998781974448},
                                  {0.0009307585041167333, 0.1762953829938977, 0.1762847338138993,
                                   0.4711351493783037},
                                  {7.935828369738902e-05, 0.002954577650579382, 0.03692599014419112,
                                   0.9231934420610384},
                                  {0.0010875879098938145, 0.021446839338156776, 0.39915131927633474,
                                   0.18025052210917375}},
                                 {{0.0005925488568399667, 0.019561396623894493, 0.07781901333037738,
                                   0.1926972698625098, 0.7099223201832183},
                                  {0.000424452702443707, 0.00913454545923239, 0.08164397664371474,
                                   0.358893424004992, 0.5503280538920609},
                                  {0.0007937783109514645, 0.04144548457433058, 0.1459328519101248,
                                   0.2623691089804096, 0.550252554535135}});
  default:
    Exit(std::format("Quadrature exact up to degree {} not implemented for tetrahedrons!",
                     exactUpTo));
  }
}

#ifdef BUILD_IA

template<>
QtetSymT_data<IAInterval> GetQtetSymT_data<IAInterval>(int exactUpTo) {
  switch (exactUpTo) {
  case 0:
  case 1:
    return QtetSymT_data<IAInterval>({{IAInterval::c6r()}}, {}, {}, {}, {});
  default:
    Exit(std::format("IAQuadrature exact up to degree {} not implemented for tetrahedrons!",
                     exactUpTo));
  }
}

#endif

#endif // QUADRATURETETRAHEDRONDATA_HPP
